% -----------------------------------------------------------------------------
% $Id: CTypes.lhs,v 1.11 2002/02/04 09:05:46 chak Exp $
%
% (c) The FFI task force, [2000..2002]
%

A mapping of C types to corresponding Haskell types.

\begin{code}
module CTypes
	( -- Integral types, instances of: Eq, Ord, Num, Read, Show, Enum,
	  -- Typeable, Storable, Bounded, Real, Integral, Bits
	  CChar(..),    CSChar(..),  CUChar(..)
	, CShort(..),   CUShort(..), CInt(..),    CUInt(..)
	, CLong(..),    CULong(..),  CLLong(..),  CULLong(..)

	  -- Floating types, instances of: Eq, Ord, Num, Read, Show, Enum,
	  -- Typeable, Storable, Real, Fractional, Floating, RealFrac,
	  -- RealFloat
	, CFloat(..),   CDouble(..), CLDouble(..),

	  -- Integral types, instances of: Eq, Ord, Num, Read, Show, Enum,
	  -- Typeable, Storable, Bounded, Real, Integral, Bits
	  CPtrdiff(..), CSize(..), CWchar(..), CSigAtomic(..)

	  -- Numeric types, instances of: Eq, Ord, Num, Read, Show, Enum,
	  -- Typeable, Storable
	, CClock(..),   CTime(..),

          -- Instances of: Eq and Storable
	, CFile,        CFpos,     CJmpBuf
	) where

import PrelCTypes
import PrelCTypesISO
\end{code}
