% -----------------------------------------------------------------------------
% $Id: MarshalError.lhs,v 1.3 2002/02/04 09:05:46 chak Exp $
%
% (c) The FFI task force, [2000..2002]
%

Marshalling support: Handling of common error conditions

\begin{code}

module MarshalError (

  -- I/O errors
  -- ----------

  IOErrorType,            -- abstract data type

  mkIOError,	          -- :: IOErrorType 
		          -- -> String 
		          -- -> Maybe FilePath 
		          -- -> Maybe Handle
		          -- -> IOError
  
  alreadyExistsErrorType, -- :: IOErrorType 
  doesNotExistErrorType,  -- :: IOErrorType 
  alreadyInUseErrorType,  -- :: IOErrorType 
  fullErrorType,	  -- :: IOErrorType 
  eofErrorType,	          -- :: IOErrorType 
  illegalOperationType,   -- :: IOErrorType 
  permissionErrorType,    -- :: IOErrorType 
  userErrorType,	  -- :: IOErrorType 

  annotateIOError,    	  -- :: IOError 
		      	  -- -> String 
		      	  -- -> Maybe FilePath 
		      	  -- -> Maybe Handle 
		      	  -- -> IOError 

  -- Result value checks
  -- -------------------

  -- throw an exception on specific return values
  --
  throwIf,       -- :: (a -> Bool) -> (a -> String) -> IO a       -> IO a
  throwIf_,      -- :: (a -> Bool) -> (a -> String) -> IO a       -> IO ()
  throwIfNeg,    -- :: (Ord a, Num a) 
	         -- =>                (a -> String) -> IO a       -> IO a
  throwIfNeg_,   -- :: (Ord a, Num a)
	         -- =>                (a -> String) -> IO a       -> IO ()
  throwIfNull,   -- ::                String        -> IO (Ptr a) -> IO (Ptr a)

  -- discard return value
  --
  void           -- IO a -> IO ()
) where

import PrelMarshalError
\end{code}
