%
% (c) The AQUA Project, Glasgow University, 1998
%

\section[NumExts]{Misc numeric bits}

\begin{code}
module NumExts

       (
         doubleToFloat   -- :: Double -> Float  -- DEPRECATED
       , floatToDouble   -- :: Float -> Double  -- DEPRECATED

       , showHex         -- :: Integral a => a -> ShowS
       , showOct         -- :: Integral a => a -> ShowS
       , showBin         -- :: Integral a => a -> ShowS

	 -- general purpose number->string converter.
       , showIntAtBase   -- :: Integral a 
			 -- => a		-- base
			 -- -> (a -> Char)      -- digit to char
			 -- -> a                -- number to show.
			 -- -> ShowS
       , showListWith    -- :: (a -> ShowS)
			 -- -> [a]
			 -- -> ShowS
       ) where

import Numeric	( showHex, showOct, showBin, showIntAtBase )
#ifdef __GLASGOW_HASKELL__
import PrelShow( showList__ )
import PrelFloat
import PrelBase
#endif /* __GLASGOW_HASKELL__ */
\end{code}

\begin{code}
{-# DEPRECATED floatToDouble "use realToFrac instead" #-}
{-# DEPRECATED doubleToFloat "use realToFrac instead" #-}

#ifdef __HUGS__
primitive doubleToFloat :: Double -> Float
primitive floatToDouble :: Float -> Double

#else 

doubleToFloat :: Double -> Float
floatToDouble :: Float -> Double

doubleToFloat (D# d#) = F# (double2Float# d#)
floatToDouble (F# f#) = D# (float2Double# f#)
#endif /* !__HUGS__ */

\end{code}

Easy enough to define by the user, but since it's
occasionally useful (when, say, printing out a 
list of hex values), we define and export it
from @NumExts@.

\begin{code}
showListWith :: (a -> ShowS) -> [a] -> ShowS 
showListWith = showList__
#ifndef __GLASGOW_HASKELL__
showList__ :: (a -> ShowS) ->  [a] -> ShowS
showList__ _     []     s = "[]" ++ s
showList__ showx (x:xs) s = '[' : showx x (showl xs)
  where
    showl []     = ']' : s
    showl (y:ys) = ',' : showx y (showl ys)
#endif
\end{code}

