-----------------------------------------------------------------------------
-- $Id: Ptr.lhs,v 1.6 2002/02/04 09:05:46 chak Exp $
-- 
-- (c) 2000
-- 
-- Module Ptr

\begin{code}
module Ptr (
    --------------------------------------------------------------------
    -- Data pointers.
    
    Ptr(..),      -- data Ptr a
    nullPtr,      -- :: Ptr a
    castPtr,      -- :: Ptr a -> Ptr b
    plusPtr,      -- :: Ptr a -> Int -> Ptr b
    alignPtr,     -- :: Ptr a -> Int -> Ptr a
    minusPtr,     -- :: Ptr a -> Ptr b -> Int
    
    --------------------------------------------------------------------
    -- Function pointers.
    
    FunPtr(..),      -- data FunPtr a
    nullFunPtr,      -- :: FunPtr a
    castFunPtr,      -- :: FunPtr a -> FunPtr b
    freeHaskellFunPtr, -- :: FunPtr a -> IO ()
    -- Free the function pointer created by foreign export dynamic.

    -- the following two functions are only valid on architectures where data
    -- and function pointers range over the same set of addresses; to ensure
    -- portable code, avoid their use where possible
    --
    castFunPtrToPtr, -- :: FunPtr a -> Ptr b
    castPtrToFunPtr, -- :: Ptr a -> FunPtr b

 ) where

import PrelPtr

foreign import "freeHaskellFunctionPtr" unsafe
    freeHaskellFunPtr :: FunPtr a -> IO ()
\end{code}
