module ObjectIO ( module StdId
             	, module StdIOBasic
             	, module StdIOCommon
             	, module StdKey
             	, module StdGUI
             	, module StdPicture
             	, module StdPictureDef
             	, module StdBitmap
             	, module StdProcess
             	, module StdProcessAttribute
             	, module StdProcessDef
             	, module StdControl
             	, module StdControlDef
	     	, module StdControlAttribute
	     	, module StdControlReceiver
	     	, module StdControlClass
             	, module StdReceiver
             	, module StdReceiverDef
             	, module StdReceiverAttribute             
             	, module StdWindow
             	, module StdWindowDef
             	, module StdWindowAttribute
             	, module StdMenu
             	, module StdMenuDef
             	, module StdMenuAttribute
             	, module StdMenuReceiver
             	, module StdMenuElement
             	, module StdTimer
             	, module StdTimerDef
             	, module StdTimerAttribute
             	, module StdTimerReceiver
             	, module StdFileSelect
             	, module StdSound
             	, module StdClipboard
             	, module StdSystem
             	, liftIO
             	) where

--	********************************************************************************
--	Clean to Haskell Standard Object I/O library, version 1.2
--
--	ObjectIO contains all definition modules of the Object I/O library.
--	********************************************************************************

import StdId			-- The operations that generate identification values
import StdIOBasic		-- Function and type definitions used in the library
import StdIOCommon		-- Function and type definitions used in the library
import StdKey			-- Function and type definitions on keyboard
import StdGUI			-- Type definitions used in the library

import StdPicture
import StdPictureDef		-- Type definitions for picture handling
import StdBitmap

import StdProcess		-- Process handling operations
import StdProcessDef		-- Type definitions for process handling
import StdProcessAttribute	-- ProcessAttribute access operations

import StdControl		-- Control handling operations
import StdControlDef		-- Type definitions for controls
import StdControlAttribute	-- ControlAttribute access operations
import StdControlReceiver
import StdControlClass		-- Standard controls class instances

import StdReceiver		-- Receiver handling operations
import StdReceiverDef		-- Type definitions for receivers
import StdReceiverAttribute	-- ReceiverAttribute access operations

import StdWindow		-- Window handling operations
import StdWindowDef		-- Type definitions for windows
import StdWindowAttribute	-- WindowAttribute access operations

import StdMenu
import StdMenuDef
import StdMenuAttribute
import StdMenuReceiver
import StdMenuElement

import StdTimer
import StdTimerDef
import StdTimerAttribute
import StdTimerReceiver

import StdFileSelect

import StdSound

import StdClipboard

import StdSystem

import IOState(liftIO)
