{-# OPTIONS -cpp #-}

module ReceiverDefAccess ( receiverDefAttributes
                         , receiverDefRId
                         , receiverDefSelectState
                         , receiverDefFunction
                         , receiverDefSetAbility
                         , receiverDefSetFunction
                         , module StdReceiverDef
                         ) where


--	********************************************************************************
--	Clean Standard Object I/O library, version 1.2
--	
--	Access functions to ReceiverDefinitions.
--	********************************************************************************


import CommonDef
import StdReceiverAttribute
import StdReceiverDef
#include "preprocess.h"
         -- Compile with -cpp; set MVAR=1 for MVAR version


receiverDefAttributes :: Receiver m r IF_MVAR(,ls ps) -> [ReceiverAttribute IF_MVAR(,ls ps)]
receiverDefAttributes (Receiver _ _ atts) = atts

receiverDefRId :: Receiver m r IF_MVAR(,ls ps) -> RId m r
receiverDefRId (Receiver rid _ _) = rid

receiverDefSelectState :: Receiver m r IF_MVAR(,ls ps) -> SelectState
receiverDefSelectState (Receiver _ _ atts) = getSelectState atts

getSelectState :: [ReceiverAttribute IF_MVAR(,ls ps)] -> SelectState
getSelectState atts
	= getReceiverSelectStateAtt selectAtt
	where
		(_,selectAtt) = cselect isReceiverSelectState defSelect atts
		defSelect     = ReceiverSelectState Able

receiverDefFunction :: Receiver m r IF_MVAR(,ls ps) -> ReceiverFunction m r IF_MVAR(,ls ps)
receiverDefFunction (Receiver _ f _) = f

receiverDefSetAbility :: SelectState -> Receiver m r IF_MVAR(,ls ps) -> Receiver m r IF_MVAR(,ls ps)
receiverDefSetAbility ability (Receiver rid f atts)
	= Receiver rid f (setSelectState ability atts)

setSelectState :: SelectState -> [ReceiverAttribute IF_MVAR(,ls ps)] -> [ReceiverAttribute IF_MVAR(,ls ps)]
setSelectState ability atts
	= snd (creplace isReceiverSelectState (ReceiverSelectState ability) atts)


receiverDefSetFunction :: ReceiverFunction m r IF_MVAR(,ls ps) -> Receiver m r IF_MVAR(,ls ps) -> Receiver m r IF_MVAR(,ls ps)
receiverDefSetFunction f (Receiver rid _ atts)
	= Receiver rid f atts
