module StdFileSelect(selectInputFile, selectOutputFile, selectDirectory) where

--	Clean Object I/O library, version 1.2

import OSFileSelect
import Scheduler
import IOState(initialContext)
import World(loadWorld, storeWorld)
import OSEvent

selectInputFile :: IO (Maybe String)
selectInputFile = do
	w <- loadWorld
	storeWorld w
	context <- initialContext w Nothing
	(mb_name,doneContext) <- osSelectInputFile handleOSEvent context
	closeContext doneContext
	return mb_name

selectOutputFile :: String -> String -> IO (Maybe String)
selectOutputFile prompt filename = do
	w <- loadWorld
	storeWorld w
	context <- initialContext w Nothing
	(mb_name,doneContext) <- osSelectOutputFile handleOSEvent context prompt filename
	closeContext doneContext
	return mb_name

selectDirectory :: IO (Maybe String)
selectDirectory = do
	w <- loadWorld
	storeWorld w
	context <- initialContext w Nothing
	(mb_name,doneContext) <- osSelectDirectory handleOSEvent context
	closeContext doneContext
	return mb_name

handleOSEvent :: OSEvent -> Context -> IO Context
handleOSEvent osEvent context
	= fmap snd (handleContextOSEvent (ScheduleOSEvent osEvent []) context)
