{-# OPTIONS -cpp #-}

module StdReceiverDef (module StdReceiverDef, module StdIOCommon, module StdGUI) where


--	********************************************************************************
--	Clean to Haskell Standard Object I/O library, version 1.2
--	
--	StdReceiverDef contains the types to define the standard set of receivers.
--	********************************************************************************


import StdGUI
import StdIOCommon
#include "preprocess.h"
         -- Compile with -cpp; set MVAR=1 for MVAR version


#if MVAR
data	Receiver         m r       = Receiver (RId m r) (ReceiverFunction m r) [ReceiverAttribute]
type	ReceiverFunction m r       = m -> GUI r
#else
data	Receiver         m r ls ps = Receiver (RId m r) (ReceiverFunction m r ls ps) [ReceiverAttribute ls ps]
type	ReceiverFunction m r ls ps = m -> (ls,ps) -> GUI ps (r,(ls,ps))
#endif

data	ReceiverAttribute IF_MVAR(,ls ps)			-- Default:
 =	ReceiverInit               (GUIFun IF_MVAR((),ls ps))	-- no actions after opening receiver
 |	ReceiverSelectState        SelectState			-- receiver Able
{-	TCP support not yet incorporated
 |	ReceiverConnectedReceivers [Id]				-- [] -- MW11++
-}

